#include "NalParser.h"
#include <time.h>

int getNalType(const unsigned char * data) {
  unsigned char c = data[2];
  if (c == 0x00) {
    c = data[4];
  } else {
    c = data[3];
  }
  return c&0x1f;
}
void 	  dump10byte(unsigned char *naldata)
{
	printf("%02x %02x %02x %02x %02x %02x %02x %02x %02x %02x \n",
		naldata[0],naldata[1],naldata[2],naldata[3],naldata[4],
		naldata[5],naldata[6],naldata[7],naldata[8],naldata[9]);
}

int keep_packet(int loss_percent)
{
  int rnd;
  if (loss_percent>100)
    return 1;
  if (loss_percent<0)
    return 0;

  rnd = int (100 * (((float) rand()) / RAND_MAX));

  return (rnd >= loss_percent );
}

int
main(int argc, char * argv[]) {
  int bUsageCorrect = 0;
  NalParser * parser1 = NULL;
  NalParser * parser2 = NULL;
  FILE      * fout = NULL;
  int       start1 = -1;
  int       end1   = -1;
  int       start2 = -1;
  int       end2   = -1;
  int       loss_percent = 0;
  int       kepp=-1;
  int		every=-1;
  char      name1[512];
  char      name2[512];
  int cont1, keep_pac, quantidade=0,total=0;
  FILE *fp;

  //srand ( time(NULL) );
  srand(58);
  if (argc == 4) {
	if (argv[1][0] == '-' && argv[1][1] == 'o') {
	  fout = fopen(argv[1]+2, "wb");
	  if (fout != NULL) {
		 {
		  char *p = argv[2];
		  while (*p) {
			if (*p == ':') *p = ' ';
			p++;
		  }
		 }
		{
		  char *p = argv[3];
		  while (*p) {
			if (*p == ':') *p = ' ';
			p++;
		  }
		}
		if ( (sscanf(argv[2], "%s %d %d", name1, &start1, &end1) == 3) &&
			 (sscanf(argv[3], "%s %d %d %d %d", name2, &loss_percent, &kepp, &every, &end2) == 5) )
		{
           //printf("%s %d %d %d %d",name2, loss_percent, kepp, every, end2); getchar();
			bUsageCorrect = 1;
		}
	  }
	}
  }
  if (bUsageCorrect == 0) {
	  printf("Usage: ElementaryStreamMerger -o{OutputFile} file1:startframe:endframe file2:losspercent:kepp_k_unit:every_m_units:endframe\n");
	return 1;
  }

  parser1 = new NalParser(name1);
  parser2 = new NalParser(name2);
  unsigned char * naldata = new unsigned char [1000000];

  uint32 nNalSize;

  int fno = 0;
  int done = 0;
  //keep leading units
   fp = fopen("log_percentage.txt","a+t");
   fprintf(fp,"\nArquivo: %s\n",name2);


  while (!done) {
	int bReadMore = parser1->getNextNal(naldata, 1000000, &nNalSize);
	if (nNalSize < 0) {
	  fprintf(stderr, "immature death in elementarystreammerger\n");
	}
	// copy sps, pps...
	int naltype = getNalType(naldata);
	if (naltype == 7 || naltype == 8) {
	  //	    printf("--- nalsize = %d\n", nNalSize);
	  fwrite(naldata, nNalSize, 1, fout);
	} else {
	  if (fno >= start1 && fno <= end1) {
	    printf("fno = %d (nalsize = %d)\t", fno, nNalSize);
		dump10byte(naldata);
	    fwrite(naldata, nNalSize, 1, fout);
		quantidade++;
		total++;
	  }
	  fno++;
	}
	if (fno > end1)
	  done = 1;
  }


  //fno = 0;
  done = 0;
  start2 = end1+1;
  cont1=start2;


  printf("start2 = %d, end2 = %d\n", start2, end2);
  while (!done) {
	int bReadMore = parser1->getNextNal(naldata, 1000000, &nNalSize);
	if (nNalSize < 0) {
	  fprintf(stderr, "immature death in elementarystreammerger\n");
	}

	// do not copy sps, pps...
	int naltype = getNalType(naldata);


	if (!(naltype == 7 || naltype == 8)) {


		if ((cont1>=kepp)&&(cont1<every))
		{
			keep_pac = keep_packet(loss_percent);
			cont1++;printf("cont %d",cont1);
		}
		else if (cont1<kepp)
		{
			keep_pac = 1;
			cont1++;printf("cont %d",cont1);
		}
		else if (cont1>=every)
		{
			cont1=1;
			keep_pac=1;
			printf("\nzerou\n");
		}

		total++;
		if (keep_pac) {
		  printf("fno = %d (nNalSize=%d)\t", fno, nNalSize);
		  dump10byte(naldata);
		  fwrite(naldata, nNalSize, 1, fout);
		  quantidade++;
		}

		fno++;
	}
	if (fno > end2)
	  done = 1;
  }

  delete [] naldata;
  fprintf(fp,"Porcentgem %f", 1 - (float)quantidade/total);
  fclose;
  return 0;
}

