#ifndef NAL_PARSER_H_
#define NAL_PARSER_H_

#include "PeekableStream.h"

class NalParser : public PeekableStream {
protected:
public:
  NalParser(const char * fname) : PeekableStream(fname) {}
  /*
   *  returns: 0 when next unread bytes are STARTCODE or eof is reached
   *  returns: 1 when incomplete are read...
   *
   *  no more nal: readSize is 0 and returns 0.
   */
  int getNextNal(uint8 * buf, uint32 bufsize, uint32 * readSize) {
	int nCopied = 0;
	int naldone = 0;

	while (nCopied < bufsize) {
	  if (bEof()) {
		naldone = 1;
		break;
	  }
	  uint8 copiedbyte = getByte();	
	  buf[nCopied++] =  copiedbyte;
	  
	  if (copiedbyte) {
		  int peekval = PeekFourBytes();
		  if ( (peekval == 0x00000001) || ((peekval>>8) == 0x000001)) {
		  //if (peekval == 0x00000001) {
			naldone = 1;
			break;
		  }	
	  }
	}
	*readSize = nCopied;
	return (naldone == 0);
  }
};


#endif // NAL_PARSER_H_
